( -*- forth -*- )

( 16bit disassembler
this is not example code :)

host

load host/dasm.f

: .reg ( x -- x )
    uppercase
    dup 0xf00 or opcode
    FSR0L FSR0H INDF0 POSTINC0 POSTDEC0 PREINC0
    FSR1L FSR1H INDF1 POSTINC1 POSTDEC1 PREINC1
    FSR2L FSR2H INDF2 POSTINC2 POSTDEC2 PREINC2
    PORTA LATA TRISA
    PORTB LATB TRISB
    PORTC LATC TRISC
    PORTD LATD TRISD
    PORTE LATE TRISE
    TOSL TOSH TOSU
    TBLPTRL TBLPTRH TBLPTRU TABLAT
    STATUS INTCON
    found? not if .8bit then drop lowercase ;


( 1 word opcodes )
: .opcode ( location opcode -- )
    
    ( 0 bit operand )
    opcode
    DUP DROP NOP RETURN PUSH POP SLEEP RETFIE RETFIE1 RESET
    TBLRD* TBLRD*+ TBLRD*- TBLRD+* TBLWT* TBLWT*+ TBLWT*- TBLWT+*
    
    found? if 2drop exit then

    ( 8 bit operand )
    0xff00 mask opcode
    MOVLW ADDLW ANDLW SUBLW IORLW XORLW RETLW
    found? if drop space tab .8bit 2drop exit then or

    ( 8 bit jump )
    0xff00 mask opcode
    BC BNC BN BNN BZ BNZ BOV BNOV
    CALL GOTO
    found? if drop space tab .8jump 2drop exit then or

    ( 9 bit operand )
    0xfe00 mask opcode
    CLRF SETF ( MULWF ) MOVWF CPFSEQ CPFSLT CPFSGT
    found? if drop tab .reg ,space .banked 2drop exit then or

    ( 10 bit operand )
    0xfc00 mask opcode
    MOVF ADDWF ANDWF IORWF XORWF INCF DECF SUBWF SUBWFB
    RLCF RLNCF RRCF RRNCF COMF NEGF SWAPF
    found? if drop tab .reg ,space .dest ,space .banked 2drop exit then or

    ( 11 bit operand )
    0xf800 mask opcode
    RCALL BRA
    found? if drop tab .11jump 2drop exit then or

    ( 12 bit operand )
    0xf000 mask opcode
    BSF BCF BTFSC BTFSS BTG
    found? if drop tab .8bit
	,space dup 1 >> .3bit drop
	,space .banked
	2drop exit then or

    ( 12 bit nop )
    dup 0xf000 and NOPF = if 2drop [h'] NOP rfind .lowstring exit then

    ( unknown opcode )
    space .word drop
;


: .opcode2 ( location -- location ? )

    ( long jump )
    dup t@ 0xff00 mask opcode CALL GOTO
    found? if 2drop space tab  >r
	r     t@ 0x00ff and
	r 2 + t@ 0x0fff and 8 << or 1 << .address cr
	r> 2 + 0 exit
    then 2drop

    ( lfsr )
    dup t@ 0xffc0 mask opcode LFSR
    found? if 2drop space tab >r
	r     t@ 4 >> 0x3 and >hex emit ,space
	r     t@ 0x000f and 8 <<
	r 2 + t@ 0x00ff and or .word cr
	r> 2 + 0 exit
    then 2drop
    
    ( movff )
    dup t@ 0xf000 mask opcode MOVFF
    found? if 2drop space tab >r
	r     t@ 0x0fff and .reg drop ,space
	r 2 + t@ 0x0fff and .reg drop cr
	r> 2 + 0 exit
    then 2drop
    
    -1 ( pass control to .opcode )
;


variable last-dasm
0 last-dasm h!

: .dasm ( start end )
    >r r last-dasm h!
    begin dup r < while
	    dup .code space
	    dup t@ .word tab
	    .opcode2 if
		dup dup t@ .opcode
		2 + cr
	    then
    repeat drop rdrop ;

: .d
    dup 0x20 + .dasm ;
: more
    last-dasm h@ dup 0x20 + .dasm ;

: savedasm
    output-file 0 there .dasm output-close ;

: tsee
    accept (tfind)
    dup 0 = if drop 0x20 then ( no length recorded? -> use default )
    over + .dasm ;
: see# tsee ;
