( -*- forth -*- )

( misc init macros )


host

( isr state saving:
saves WREG and STATUS
FSR and INDF are not saved.
can only use movwf for store and swapf for load )

: context!, ( buf -- )
    <lit, 
    dup movwf, dup swapf, f,       ( swap & save w reg )
    STATUS swapf, dup 1 + movwf,   ( swap & save status )
    ( PCLATH swapf, dup 2 + movwf, ( swap & save pclath )
    drop ;
    

: context@, ( buf -- )
    <lit,
    ( dup 2 + swapf, PCLATH movwf, )
    dup 1 + swapf,
    STATUS movwf, dup swapf,
    drop ;

: context@!, ( srcbuf dstbuf -- )
    <lit, <lit,
    2dup lit, lit, @!,
    1 + swap 1 + swap lit, lit, @!, ;
    


: task#  variable# 1 allot# ;
    
: cli,   INTCON GIE bcf, ;
: sti,   INTCON GIE bsf, ;



