( -*- forth -*- )
host


: vector! ( address xt -- )
    there >r 2 * xt-table + there! jump, r> there! ;	

variable xtfree 0x10 xtfree h!
: nextxt xtfree h@ 1 xtfree h+! ;

: vector# ( address -- )
    nextxt vector! ;

target

( execute
since we're 8bit, and it's nice to have execution tokens
fit into a cell, xts are indirect, and point to word
aligned code vectors starting at 0x0000 )

( we can't write directly to PCL without trashing WREG
because we can't use movff, so we use the return stack )


( xt -- )
: execute
    push rot< dup
    0x1  and TOSH !
    [ xt-table 8 >> ]L TOSH +!
    0xfe and TOSL ! ;
