( -*- forth -*- )

target

( some extras for interpreter / interactive mode )

( execute foreign code:
this saves the state of the data and aux stack before calling,
and returns contents of WREG on top of data stack )
: foreign ( inarg -- outarg )
    saveforth jsr restoreforth ;

( debug led )
: on  TRISA 0 low PORTA 0 high ;
: off TRISA 0 low PORTA 0 low ;
: hiz TRISA 0 high ;

: wait 0 for 0 for next next ;
: blink on wait off ;
: init
    0 TRISA !
    0 TRISB !
    0xC0 TRISC and! ; ( don't touch uart pins 6+7 )


: command? rx-ready high? ;
    
host
( load this file right after loading app/monitor.f
so the extensions will be saved in the image file )
saveforth image/monitor.f
    
