( -*- forth -*- )
( return stack 'local variables' )
: rl,       TOSL, ;
: rh,       TOSH, ;

( for counters )
: rl++,     TOSL incf, f, ;
: rl--,     TOSL decf, f, ;
: rh++,     TOSH incf, f, ;
: rh--,     TOSH decf, f, ;

( push/pop might block opti?? )
: loop,   push, rl--, rl--, ;               ( push location )
: >r,     push, rl, !, ;                    ( move byte to/from return stack )
: r>,     rl, @, pop, ;
: >>r,    push, rh, !, rl, !, ;             ( move word to/from return stack )
: r>>,    rl, @, rh, @, pop, ;
: rdrop,  pop, ;

