( -*- forth -*- )

( this loads the stc forth with support for the current
monitor code in the target.

you need to run app/monitor.f to compile imaged/monitor.f )

host


load host/compiler.f   ( target compiler )
load stc16/core.f      ( core forth macros + code )

0x8000 tcode           ( allocate target code buffer )

host
load image/usbstamp_current.f  ( load monitor image. includes boot code. )

( host interactive support code )
: recompile ( dummy ) ;
load host/interactive.f
load wisp/18f452.f

( picstamp macros )
macro
: red   LATB 0 ;
: green LATB 1 ;
: blue  LATB 2 ;



host
