( -*- forth -*- )

( attempt to write a replacement for the wisp firmware
to be used with badnop.

io pins

clock_pin      is pin_a0  -- target RB6          3 GREEN
reset_pin      is pin_a1  -- 
dummy_1_pin    is pin_a2  --
dummy_2_pin    is pin_a3  --
dummy_3_pin    is pin_a4  --
dummy_4_pin    is pin_a5  --
pump_1_pin     is pin_b0  --
async_in_pin   is pin_b1  --                     HOST -> WISP
async_out_pin  is pin_b2  --                     WISP -> HOST
pump_2_pin     is pin_b3  -- 
aux_2_pin      is pin_b4  --                     8 TARGET -> WISP
data_pin       is pin_b5  -- target RB7          4 BLUE
aux_1_pin      is pin_b6  -- short target Vcc    7 WISP -> TARGET
pulldown_pin   is pin_b7  -- target PGM          6 WHITE




wait loops cycle the charge pump.
when they are inputs, the cycle has no effect, only timing.

pump_cycle: 10us


how to proceed?

* build monitor/interpreter for 16f628

)

load stc14/16f628.f

target


: portA
    0 bank 0 PORTA ! 7 CMCON !
    1 bank 0x1f TRISA ! 
    0 bank ;


: wait0  1- z? if drop exit then wait0 ;
: wait1  1- z? if drop exit then 0 wait0 wait1 ;
: wait   0 wait1 ;

: on  0xff PORTA ! ;
: off 0x00 PORTA ! ;

: blink
    wait on
    wait off
    blink ;


application : main portA blink ;

echo application: there 2 / .x cr

savehex blink.hex

load comp/wisp_16f628.f





