( -*- forth -*- )

( assembler + very crude feature-poor forth )



( 16F62X 12F675 instruction set )

: ADDWF  0x0700 ;
: ANDWF  0x0500 ;
: CLRF   0x0180 ;
: CLRW   0x0100 ;
: COMF   0x0900 ;
: DECF   0x0300 ;
: DECFSZ 0x0B00 ;
: INCF   0x0A00 ;
: INCFSZ 0x0F00 ;
: IORWF  0x0400 ;
: MOVF   0x0800 ;
: MOVWF  0x0080 ;
: NOP    0x0000 ;
: RLF    0x0D00 ;
: RRF    0x0C00 ;
: SUBWF  0x0200 ;
: SWAPF  0x0E00 ;
: XORWF  0x0600 ;

: BCF    0x1000 ;
: BSF    0x1400 ;
: BTFSC  0x1800 ;
: BTFSS  0x1C00 ;

: ADDLW  0x3E00 ;
: ANDLW  0x3900 ;
: CALL   0x2000 ;
: CLRWDT 0x0064 ;
: GOTO   0x2800 ;
: IORLW  0x3800 ;
: MOVLW  0x3000 ;
: RETFIE 0x0009 ;
: RETLW  0x3400 ;
: RETURN 0x0008 ;
: SLEEP  0x0063 ;
: SUBLW  0x3C00 ;
: XORLW  0x3A00 ;


( rpn assembler )
: lop >r 0xff and r> or ; ( lit opcode -- )
: fop >r 0x7f and r> or ; ( reg opcode -- )
: bop >r 0x7 and 7 << swap 0x7f and or r> or ; ( reg bit opcode -- )

: lop: : lit_ lop_ ,_ ;_ ;
: fop: : lit_ fop_ ,_ ;_ ;
: bop: : lit_ bop_ ,_ ;_ ;

: prev there 2 - ;
: f, prev t@ 0x80 or prev t! ;

( reg ops: reg --  )
MOVWF  fop: movwf,
MOVF   fop: movf,
ADDWF  fop: addwf,
SUBWF  fop: subwf,
CLRF   fop: clrf,
DECF   fop: decf,
INCF   fop: incf,
DECFSZ fop: decfsz,
INCFSZ fop: incfsz,
ANDWF  fop: andwf,
IORWF  fop: iorwf,
XORWF  fop: xorwf,
SWAPF  fop: swapf,
COMF   fop: comf,
RLF    fop: rlf,
RRF    fop: rrf,

( literal ops: lit -- )
MOVLW lop: movlw,
ADDLW lop: addlw,
SUBLW lop: sublw,
IORLW lop: iorlw,
XORLW lop: xorlw,
ANDLW lop: andlw,
RETLW lop: retlw,

( bit ops: reg bit -- )
BCF bop: bcf,
BSF bop: bsf,
BTFSC bop: btfsc,
BTFSS bop: btfss,


( misc ops )
: return, RETURN , ;
: nop,    NOP , ;
: clrwdt, CLRWDT , ;
: sleep,  SLEEP , ;

( branching )
: call?       prev t@ 0x3800 and CALL = ;
: call,       2 / 0x7ff and CALL or , ;
: jump,       2 / 0x7ff and GOTO or , ;

: reset,  0 jump, ;

( conditional branching )
: SET    0x0400 ; ( bit test modifier )
: CLR    0x0000 ;
: btfs,  BTFSC or bop , ;


( conditions: machine flags )
: z?,    STATUS Z SET ;  
: nz?,   STATUS Z CLR ;  
: c?,    STATUS C SET ;
: nc?,   STATUS C CLR ;


( bank select )
: bank0, STATUS RP0 bcf, ;
: bank1, STATUS RP0 bsf, ;

load asm/dasm14bit.f
