( -*- forth -*- )
( forth style macros for dtc forth )
( forth style macros )

: a!,        w=pop, al=w, w=pop, ah=w, ;
: @a+,       w=*a++, push=w, w=*a++, push=w, ;    ( fetch from *a, increment a )
: !a,        w=pop, *++a=w, a--, w=pop, *a=w, ;   ( store to *a )
: @a,        w=*a++, push=w, w=*a, push=w, a--, ; ( fetch from *a )
: r>ip,      w=TOSL, ipl=w, w=TOSH, iph=w, pop, ;
: r<>ip,
    w=ipl, ipl=TOSL, TOSL=w,
    w=iph, iph=TOSH, TOSH=w, ; ( exchange ip and r )
: _r,      w=TOSH, push=w, w=TOSL, push=w, ;
: _>r,     push, w=pop, TOSL=w, w=pop, TOSH=w, ;

( 2op compiling ) ( OPH OPL -- )
: yx>y,
    x0 fetch, ( OPL ) y0 swap fop, f,   ( perform OPL )
    x1 fetch, ( OPH ) y1 swap fop, f, ; ( perform OPH )

( prepended with _ to not clash with DTC versions )

: _ifz, there BNZ , ;
: _ifnz, there BZ , ;
: _ifc, there BNC , ;
: _ifnc, there BC , ;


: _then,                    ( can be used to patch any conditional reljump )
    patch-cjump,            ( it can patch forward bra too )
    peephole reset ;
: _skip,
    there BRA , ;
: _else,                    ( patch first cond jump and set new uncond )
    _skip, >r patch-cjump, r> ;

: _other, exit, _then, ;
