( -*- forth -*- )

( CIRCULAR BUFFERS )
( not using FSR, since current @ and ! disable interrupts,
which increases interrupt jitter )

: reader# ( addr mask -- )
    tword
    INDF rlf, dup 1 << andlw, wjump,  ( shift, mask and jump )
    there swap 1 +                    ( addr return count )
    INDF movwf, exit,
    for
        swap dup xt[ movf, ]xt 1 +
        swap dup xt[ jump, ]xt
    next 2drop ;

