( -*- forth -*- )

( condition generators and branching )
( condition generators )
: high?, <lit, <lit, swap SET ;
: low?,  <lit, <lit, swap CLR ;

( with explicit TOS test )
: 0?,    w=top, z?, ; 
: <>0?,  w=top, nz?, ;

: test,  <lit, 0 movlw, xorwf, ;


( conditional branching:
these only use flags or bit test instructions! )


( backward jumps are not a problem )
: begin,  there ;
: again,  jump, ;
: until,  btfs, jump, ;
( : while,  SET xor until, ; ( this is nonstandard = not until )

( optimized )



( compile a patchable forward branch: -- address )
: forward, there takeoff 0 jump, ;

( if there's just one instruction inbetween if and here
we can get rid of the skipping jump and reverse polarity )

: invert SET xor ;


: (skipthen),
    ( checkme )
    drop
    prev t@ undo prev t!      ( move instruction back )
    2prev t@ invert 2prev t!  ( reverse polarity )
    landing ;

: (then),
    there >r there! r jump, r> there! landing ;

: skipcell? ( addr -- addr ? )
    dup 2prev =                 ( one ins between goto to patch and here )
    3prev t@ 0x3800 and BTFSC = ( the one before that is a bit test skip )
    and ;

: then,  skipcell? if (skipthen), exit then (then), ;
: else,  >r forward, r> (then), ;
: if,    btfs, forward, ;


: while,  if, ;
: repeat, swap again, then, ;


