( -*- forth -*- )
( very small experimental stc forth for 14bit archs )

( forth map

subroutine threaded. [can't read from flash]
WREG = scratch
FSR  = datastack

most ops are only implemented for literal arguments )


load host/compiler.f ( code generation and support )
0x800  tcode         ( create code buffer )
0x3fff tmask         ( set word mask for t@ and t! )

load asm/14bit.f     ( target assembler )
load stc14/target.f  ( the highlevel compiler )
load stc14/boot.f    ( boot code, macros and dup )
load stc14/lit.f     ( literals compilation )
load host/constant.f ( target constants )
load host/macro.f    ( macro mode overrides )
load stc14/data.f    ( data manips )
load stc14/cbra.f    ( conditionals )


( memory allocation )
load host/mem.f  ( shared between other forths )
0x20 bytefree h! ( start allocating at 0x20 )


( misc )
load stc14/table.f  ( computed goto and lookup tables )
load stc14/init.f   ( init macros )

( host/target aliases )
load host/view.f

host
