( -*- forth -*- )

( jump tables )

( simplified: one global jumptable, so PCLATH can be set to
a constant value, and we can use a store to PCL to access

see stc14/boot.f for xt allocation )

( ROUTE )

: wjump,
    xt-current addlw,  
    PCL movwf, ;       
    
: jumptos, w=pop, wjump, ;

: terminator   vector <exit,> ;
: compiler     vector <compile,> xt[ jump, ]xt ;

: route,       jumptos, terminator compiler ;


( TABLE )

: calltable,
    there 6 + call,    
    INDF movwf, f,     
    exit,
    INDF movf, wjump, ;

: compiler     vector <lit,> xt[ retlw, ]xt ;
: table,       calltable, terminator compiler ;


