( -*- forth -*- )

( this loads the stc forth with support for the current
monitor code in the target.

you need to run app/monitor.f to compile imaged/monitor.f )

host


load host/compiler.f   ( target compiler )
load stc16/core.f      ( core forth macros + code )

0x8000 tcode           ( allocate target code buffer )

host
load image/current.f   ( load current monitor image. includes boot code. )

: reload    [empty-load] stc16/interactive.f ;  ( reload current image )
: recompile [empty-load] stc16/monitor.f ;      ( recompile monitor )

( host interactive support code )
load host/interactive.f
load wisp/18f452.f

