( -*- forth -*- )

( stack manips )
: nfdrop,        POSTDEC0 WREG movff, ;   ( does not affect flags )
: test,          0xff andlw, ;            ( test Z and N flags from word on tos )
: >flags,        test, nfdrop, ;
    
    
: dup,  record DUP , ;
: dup?  prev t@ DUP =  last? and ;
: drop? prev t@ DROP = last? and ;

: drop,  dup?  if rewind else record DROP , then ;
: save,  drop? if rewind else dup, then ;
( HINT: drop, is the inverse of save, )



( perform a storing macro. this will undo dup or compile drop after the body. )
: storer
    dup? if rewind else        ( if dup, undo it and return )
	atexit drop, then ;    ( if not, make caller return to drop, )


