( -*- forth -*- )

( native code compiler )

( STC enter = nop )

: tailcall? call? rcall? or ;
: tailcall, call? if atailcall, exit then rtailcall, ;

: enter, ;                       ( -- )   ( called after docolon )
: exit,                          ( compile a tail call or a return )
    tailcall? if tailcall, exit then
    lit? if <lit, save, retlw, exit then
    RETURN , ;
: compile, call, ;         ( subroutine threaded XT compilation )

variable <exit,>
: default-exit    vector <exit,>    exit, ;
: default-compile vector <compile,> compile, ;

: ;, <exit,> h@ execute
    there erecord          ( record end for see to work )
    peephole reset [_ ;    ( stack needs to be reset )

: :# default-exit default-compile tword ] ;


load host/macro.f  ( macro mode overrides ) 

( set vector for kernel )
<h'> compile, <compile,> h!
