( -*- forth -*- )

host
( synth interaction using the interactive 18f monitor )

load stc16/interactive.f ( assume current.f contains synth/control.f )
load wisp/12f675.f       ( for connect )

variable count 0 count h!

( incremental upload )
: x
    >target count h@ >target
    synth!# sync 
    1 count h+! ;
: patch
    frt# sync
    0 count h! ;
( : go go& ; ( override wisp's go )


( incremental upload to controller,
block upload to target )
( : patch   0x100 a! 0 count h! ;
: x       !a+ 1 count h+! ;
: upload  count h@ >target transfer& sync ; )


( patches )
load synth/host.f
load synth/patch.f



ping target incremental ports



( some measurements with 12f629 chip:
* using protection diode for cap charging
* controller chip [18f252] @ 5V
* driving max input @ 4V [ output drop + protection diode drop ]
* 1/3 8000Hz 1V ripple with 100nF buffer cap
* this gives about 1.2 mA current, which is conform spec. )



