( -*- forth -*- )



load stc16/stc.f
load stc16/serial.f
load stc16/program.f
load stc16/monitor.f


target

variable x
variable y
variable z

( buffer rx
buffer tx )

flag f

: test1  1 x ! 2 y ! 3 z ! ;
: test2  x @ y @ z @ ;
: test3  1 x +! ;
: test4  3 for 0xee next ;
: test5  z nop @ ;
: test6  [ 0x40 ]a! 1 5 !i 2 6 !i ;
: test7  f high f high? f low? ;
: test8  f low f high? f low? ;
: test9  f low f low? if 0xaa else 0xbb then ;
: test10 1 2 + z? if 0xaa else 0xbb then ;

: nop3 nop nop nop ;
: test11 1 2 + nz? if nop3 exit then ;

: aabb if 0xaa else 0xbb then ;

: test12 1 aabb 0 aabb ;
: test13 f low f low? if nop then ;
    

( chip startup )
: start test1 test2 test3 test4 test5 test6 0 ;
: start test4 test6 0xff 0 ;
: start 0xa test7 test8 0xb 0 ;
: start 0xa test10 0xb 0 ;
: start 0xa test12 0xb 0 ;
: start test11 ;
: start 0xa test9 0xb 0 ;
: start 0xa test13 0xb 0 ;

( : test14 rx full? if exit  then 0xdd write test14 ;
: test15 rx empty? if exit then read test15 ; )

( fake serial )

: test16 nop nop      8 for @p+ !a+ next ;
: test17 nop nop 0xaa 8 for dup !a+ next ;
: test19 nop nop      8 for test16 test17 next ;
: test20 test16 test17 test19 ;

: test21 
    0xaa x ! 0xbb y ! 0xcc z !
    [ 0 ]a! [ 0x400 ]p! program64 ;

application
: test22 begin rx read tx write again ;

( application : main interpreter ; )



savehex test.hex

load wisp/18f452.f
