( -*- forth -*- )
( 12f675 specific )

load wisp/wisp.f
0x4 algo

( redefine erase, to save calib data )
: erase
    code 0x3ff jump read     ( save calib )
    0xe (program)            ( erase chip )
    code 0x3ff jump write ;  ( restore calib )
    
( hardcoded )
: write-fuses
    ( 13-12 bandgap [i think i thrashed this )
    ( 11- 9  unimplemented )
    ( 8     data code protect, active low )
    ( 7     code protect )
    ( 6     brown out detect )
    ( 5     mclre 1 = reset 0 = internal )
    ( 4     power up timer, active low )
    ( 3     watchdog timer )
    ( 2-0   osc select )
    fuses 0x2007 jump 0x11c4 write ;


( need to be redefines because erase is redefined )
: burn wisp erase code write-buffer write-fuses ;





